<?php
/**
 * @package     Joomla.Site
 * @subpackage  Layout
 *
 * @copyright   Copyright (C) 2005 - 2019 Open Source Matters, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 *
 * html5 (chosen html5 tag and font header tags)
 */

defined('_JEXEC') or die;

use HelixUltimate\Framework\Platform\Helper;

defined('_JEXEC') or die;

$module  = $displayData['module'];
$params  = $displayData['params'];
$attribs = $displayData['attribs'];

if ($module->content === null || $module->content === '')
{
	return;
}
$moduleTag     = htmlspecialchars($params->get('module_tag', 'div') ?? "", ENT_QUOTES, 'UTF-8');
$bootstrapSize = (int) $params->get('bootstrap_size', 0);
$moduleClass   = $bootstrapSize !== 0 ? ' span' . $bootstrapSize : '';
$headerTag     = htmlspecialchars($params->get('header_tag', 'h3') ?? "", ENT_QUOTES, 'UTF-8');
$headerClass   = htmlspecialchars($params->get('header_class', 'sp-module-title') ?? "", ENT_COMPAT, 'UTF-8');
$moduleClassSfx = Helper::CheckNull($params->get('moduleclass_sfx'))?  : '';
$encodedModuleClassSfx = is_string($moduleClassSfx) ? htmlspecialchars($moduleClassSfx, ENT_COMPAT, 'UTF-8') : '';

if ($module->content) {
    echo '<' . $moduleTag . ' class="sp-module ' . $encodedModuleClassSfx . $moduleClass . ' " data-wow-delay=".2s">';
	if ($module->showtitle != 0) {
			
		if ($module->showtitle != 0) {
			$title = explode(':', trim($module->title));
		}
		if(count($title) == 2) {
			echo '<' . $headerTag . ' class="' . $headerClass . '">';
			echo  "<span class=\"title-left\">{$title[0]}</span>";
			echo  "<span class=\"title-right\">{$title[1]}</span>";				
			echo '</' . $headerTag . '>';
		} else {
			echo '<' . $headerTag . ' class="' . $headerClass . '">' . $module->title . '</' . $headerTag . '>';
		}
	}

	echo '<div class="sp-module-content">';
	echo $module->content;
	echo '</div>';
	echo '</' . $moduleTag . '>';
}
